'use strict';

exports.__esModule = true;
exports.getUploadURL = getUploadURL;
exports.getUploadStatus = getUploadStatus;
exports.uploadZip = uploadZip;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _request = require('./request');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const baseURL = 'http://localhost:3000'
const baseURL = 'https://u9clp8v4we.execute-api.eu-west-1.amazonaws.com/dev';

function options(token, url, method) {
  return {
    method: method || 'GET',
    url: baseURL + url,
    headers: {
      Authorization: `Token ${token}`,
      'User-Agent': 'SKPM-Release-Agent'
    }
  };
}

function getUploadURL(token, manifest) {
  const opts = options(token, '/upload', 'POST');
  opts.json = manifest;
  return (0, _request.request)(opts).then(res => res.data);
}

function getUploadStatus(token) {
  return (0, _request.request)(options(token, '/check-upload-status'));
}

function uploadZip(presignedURL, zipPath) {
  const asset = _path2.default.join(process.cwd(), zipPath);
  return new Promise((resolve, reject) => {
    _fs2.default.readFile(asset, (err, content) => {
      if (err) {
        return reject(err);
      }
      const opts = {
        url: presignedURL,
        method: 'PUT',
        body: content
      };

      return resolve((0, _request.request)(opts));
    });
  });
}